#include <bits/stdc++.h>
using namespace std;
long long n, k,mini;
string a,srt;
char pos;
long long niz[30][200007];
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n >> k;
    cin >> a;
    srt=a;
    sort(srt.begin(),srt.end());
    pos=srt[n-1];
    if (srt==a){
        for (int i=0;i<n;i++){
            if (srt[i]!=pos){
                cout << 1 << " ";
            }
            else{
                cout << 2 << " ";
            }
        }
        cout << endl;
        return 0;
    }
    a=' '+a;  // da bi bili indeksirani od keca
    for (int i=1;i<=n;i++){
        niz[a[i]-'a'+1][i]++; // a=1;b=2,...
        for (int j=1;j<=k;j++){
            niz[j][i]+=niz[j][i-1];
        }
        mini=1e9;
        for (int j=1;j<=k;j++){
            mini=min(mini, niz[j][i]);
        }

    cout << mini+1<< " ";
    }
    cout << '\n';

    return 0;
}